<template>
  <div class="audit-question-unsubmit">
    <el-form class="part-filter-form" inline>
      <el-form-item label="提交人">
        <el-input
          v-model="filter.creatorName"
          placeholder="请输入提交人姓名"
        ></el-input>
      </el-form-item>
      <el-form-item label="题干内容">
        <el-input v-model="filter.name" placeholder="请输入题干内容"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="danger" @click="toPage(1)">查询</el-button>
      </el-form-item>
    </el-form>

    <div>
      <el-table
        v-loading="loading"
        element-loading-text="拼命加载中"
        :data="dataList"
      >
        <el-table-column label="试题">
          <template slot-scope="scope">
            <rich-text
              class="row-question-body"
              title="点击查看试题"
              :text-json="scope.row.quesBody"
            ></rich-text>
          </template>
        </el-table-column>
        <el-table-column label="课程">
          <template slot-scope="scope">
            <span
              >{{ scope.row.course.name }}（{{ scope.row.course.code }}）</span
            >
          </template>
        </el-table-column>
        <el-table-column label="提交人" prop="creator" width="150">
        </el-table-column>
        <el-table-column label="修改时间" prop="updateTime" width="153">
        </el-table-column>
        <el-table-column label="操作" width="170" fixed="right">
          <template slot-scope="scope">
            <div class="operate_left">
              <el-button
                size="mini"
                type="primary"
                plain
                @click="toEdit(scope.row)"
                >编辑</el-button
              >
              <el-button
                size="mini"
                type="primary"
                plain
                @click="toSubmit(scope.row)"
                >提交</el-button
              >
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          :current-page="currentPage"
          :page-size="pageSize"
          :page-sizes="[10, 20, 50, 100, 200, 300]"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
          @current-change="toPage"
          @size-change="handleSizeChange"
        >
        </el-pagination>
      </div>
    </div>

    <!-- QuestionEditDialog -->
    <question-edit-dialog
      ref="QuestionEditDialog"
      :question="curQuestion"
      @modified="getList"
    ></question-edit-dialog>
  </div>
</template>

<script>
import { auditQuestionsUnsubmitPageListApi, submitQuestionApi } from "../api";
import QuestionEditDialog from "../components/QuestionEditDialog.vue";

export default {
  name: "AuditQuestionUnsubmit",
  components: { QuestionEditDialog },
  data() {
    return {
      filter: { creatorName: "", name: "" },
      dataList: [],
      currentPage: 1,
      pageSize: 10,
      total: 0,
      loading: false,
      curQuestion: {},
    };
  },
  mounted() {
    this.toPage(1);
  },
  methods: {
    toPage(page) {
      this.currentPage = page;
      this.getList();
    },
    async getList() {
      this.loading = true;
      const res = await auditQuestionsUnsubmitPageListApi({
        ...this.filter,
        curPage: this.currentPage,
        pageSize: this.pageSize,
      }).catch(() => {});
      this.loading = false;
      if (!res) return;
      this.dataList = res.data.content;
      this.total = res.data.totalElements;
    },
    handleSizeChange(val) {
      this.pageSize = val;
      this.toPage(1);
    },
    toEdit(row) {
      const courseInfo = {
        courseId: row.course.id,
        courseCode: row.course.code,
        courseName: row.course.name,
      };
      let curQuestion = {
        ...row,
        ...courseInfo,
      };
      if (curQuestion.subQuestions && curQuestion.subQuestions.length) {
        curQuestion.subQuestions = curQuestion.subQuestions.map((q) => {
          return { ...q, ...courseInfo };
        });
      }
      this.curQuestion = curQuestion;

      this.$refs.QuestionEditDialog.open();
    },
    async toSubmit(row) {
      const confirm = await this.$confirm(`确定要提交该试题吗?`, "提示", {
        type: "warning",
      }).catch(() => {});
      if (confirm !== "confirm") return;

      await submitQuestionApi([row.id]);
      this.$message.success("操作成功！");
    },
  },
};
</script>
